<script>
import Vue from 'vue';

export default Vue.extend({
  name: 'SectionReverse',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    hasGradient: {
      type: Boolean,
      required: false,
      default: false,
    },
    hasDarkBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
    offsetImage: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  computed: {
    getPageName() {
      return this.$parent.content.slug;
    },
    cssImageProps() {
      return {
        '--margin-top': `${this.offsetImage}px`,
      };
    },
  },
});
</script>

<template>
  <div
    class="slp-py-96"
    :class="
      hasDarkBackground
        ? 'kubecon-section__dark'
        : hasGradient
          ? 'kubecon-section'
          : ''
    "
  >
    <SlpContainer>
      <SlpRow :class="data.centered ? 'centered' : ''">
        <SlpColumn
          :cols="6"
          :style="data.alignTop ? 'align-self: top' : 'align-self: center'"
        >
          <div
            class="kubecon-section__img-wrapper"
            :class="[
              offsetImage ? 'kubecon-section__img--offset' : '',
              !data.cropped ? 'not-cropped' : '',
            ]"
            :style="cssImageProps"
          >
            <nuxt-img
              class="kubecon-section__img"
              :class="`kubecon-section__img--${data.image.class}`"
              :src="`/nuxt-images/events/${getPageName}/${data.image.src}`"
              :alt="data.image.alt"
              format="webp"
              quality="99"
            />
          </div>
        </SlpColumn>
        <SlpColumn
          :cols="6"
          class="slp-pl-lg-24"
          :class="hasDarkBackground ? 'kubecon-section__dark-text' : ''"
        >
          <img
            v-if="data.icon"
            :src="`/nuxt-images/icons/events/${data.icon}`"
            alt=""
            class="slp-mb-8"
          />
          <SlpTypography
            v-if="data.title"
            :variant="hasGradient ? 'heading2-bold' : 'heading4-bold'"
            tag="h3"
            class="slp-pb-24"
          >
            {{ data.title }}
          </SlpTypography>
          <div v-for="(item, index) in data.subheadings" :key="index">
            <SlpTypography variant="body1-bold">
              {{ item.title }}:
            </SlpTypography>
            <SlpTypography variant="body1">
              {{ item.value }}
            </SlpTypography>
          </div>
          <SlpTypography variant="body1" tag="div" class="slp-py-24">
            <span
              class="information"
              v-html="$md.render(data.information)"
            ></span>
          </SlpTypography>
          <SlpTypography
            v-if="data.note"
            class="slp-pb-32"
            variant="body3"
            tag="p"
            >{{ data.note }}</SlpTypography
          >
          <SlpButton
            v-if="data.call_to_action"
            :href="data.call_to_action.button_link"
            :data-ga-name="data.call_to_action.button_text"
            data-ga-location="body"
            class="slp-mb-48"
            :variant="hasDarkBackground ? 'secondary' : 'primary'"
            >{{ data.call_to_action.button_text }}</SlpButton
          >
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.kubecon-section {
  background: linear-gradient(
    165.41deg,
    #fadcd7 0%,
    #f8f5ff 23.65%,
    #ffffff 54.66%,
    #f6f3fe 80.95%,
    #ffd4d8 100.92%
  );

  &__dark {
    background: $color-surface-700;

    &-text {
      color: $color-text-50;
    }
  }

  &__img-wrapper {
    border-radius: 4px 4px 90px 4px;
    overflow: hidden;
    object-fit: cover;
    position: relative;
    display: block;
    line-height: 0;

    &.not-cropped {
      border-radius: 0;
    }
  }
  &__img {
    max-width: 100%;
    height: 100%;
    width: 100%;

    @media screen and (min-width: $breakpoint-md) {
      &--offset {
        position: relative;
        margin-top: var(--margin-top);
      }
    }
    &--cropped {
      width: 126%;
      height: auto;
      max-width: none;
    }
  }
}

.accent-colour {
  color: $color-accent-300;
}

.centered {
  align-items: flex-start;
}

.information {
  display: block;
  &:deep p {
    display: block;
    margin-bottom: $spacing-16;
  }
}
</style>
